/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;

import java.util.Objects;

/**
 * MedicalConsultationCreation
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class MedicalConsultationCreation {
  @SerializedName("appointment_period")
  private AppointmentPeriod appointmentPeriod = null;

  @SerializedName("effective_period")
  private EffectivePeriod effectivePeriod = null;

  @SerializedName("address")
  private Model12 address = null;

  @SerializedName("phones")
  private Model13 phones = null;

  @SerializedName("reason")
  private String reason = null;

  @SerializedName("channel")
  private String channel = null;

  @SerializedName("customer_journey_step")
  private String customerJourneyStep = null;

  @SerializedName("is_the_requester_the_patient")
  private Boolean isTheRequesterThePatient = null;

  public MedicalConsultationCreation appointmentPeriod(AppointmentPeriod appointmentPeriod) {
    this.appointmentPeriod = appointmentPeriod;
    return this;
  }

   /**
   * Get appointmentPeriod
   * @return appointmentPeriod
  **/
  @ApiModelProperty(value = "")
  public AppointmentPeriod getAppointmentPeriod() {
    return appointmentPeriod;
  }

  public void setAppointmentPeriod(AppointmentPeriod appointmentPeriod) {
    this.appointmentPeriod = appointmentPeriod;
  }

  public MedicalConsultationCreation effectivePeriod(EffectivePeriod effectivePeriod) {
    this.effectivePeriod = effectivePeriod;
    return this;
  }

   /**
   * Get effectivePeriod
   * @return effectivePeriod
  **/
  @ApiModelProperty(value = "")
  public EffectivePeriod getEffectivePeriod() {
    return effectivePeriod;
  }

  public void setEffectivePeriod(EffectivePeriod effectivePeriod) {
    this.effectivePeriod = effectivePeriod;
  }

  public MedicalConsultationCreation address(Model12 address) {
    this.address = address;
    return this;
  }

   /**
   * Get address
   * @return address
  **/
  @ApiModelProperty(value = "")
  public Model12 getAddress() {
    return address;
  }

  public void setAddress(Model12 address) {
    this.address = address;
  }

  public MedicalConsultationCreation phones(Model13 phones) {
    this.phones = phones;
    return this;
  }

   /**
   * Get phones
   * @return phones
  **/
  @ApiModelProperty(value = "")
  public Model13 getPhones() {
    return phones;
  }

  public void setPhones(Model13 phones) {
    this.phones = phones;
  }

  public MedicalConsultationCreation reason(String reason) {
    this.reason = reason;
    return this;
  }

   /**
   * Reason of the consultation
   * @return reason
  **/
  @ApiModelProperty(example = "headaches", value = "Reason of the consultation")
  public String getReason() {
    return reason;
  }

  public void setReason(String reason) {
    this.reason = reason;
  }

  public MedicalConsultationCreation channel(String channel) {
    this.channel = channel;
    return this;
  }

   /**
   * Channel prefered by the customer. Expected values (VIDEO, AUDIO)
   * @return channel
  **/
  @ApiModelProperty(example = "VIDEO", value = "Channel prefered by the customer. Expected values (VIDEO, AUDIO)")
  public String getChannel() {
    return channel;
  }

  public void setChannel(String channel) {
    this.channel = channel;
  }

  public MedicalConsultationCreation customerJourneyStep(String customerJourneyStep) {
    this.customerJourneyStep = customerJourneyStep;
    return this;
  }

   /**
   * Customer Journey Step - Example of values (ON_QUALIFICATION, WAITING_DOCTOR, WITH_DOCTOR, PRESCRIPTION_SENDING_IDENTIFIED, PRESCRIPTION_READY_TO_BE_SENT, PRESCRIPTION_SENT
   * @return customerJourneyStep
  **/
  @ApiModelProperty(example = "PRESCRIPTION_READY_TO_BE_SENT", value = "Customer Journey Step - Example of values (ON_QUALIFICATION, WAITING_DOCTOR, WITH_DOCTOR, PRESCRIPTION_SENDING_IDENTIFIED, PRESCRIPTION_READY_TO_BE_SENT, PRESCRIPTION_SENT")
  public String getCustomerJourneyStep() {
    return customerJourneyStep;
  }

  public void setCustomerJourneyStep(String customerJourneyStep) {
    this.customerJourneyStep = customerJourneyStep;
  }

  public MedicalConsultationCreation isTheRequesterThePatient(Boolean isTheRequesterThePatient) {
    this.isTheRequesterThePatient = isTheRequesterThePatient;
    return this;
  }

   /**
   * Indicates if the consultation concerns the customer himself (herself) or someone else (child for example)
   * @return isTheRequesterThePatient
  **/
  @ApiModelProperty(example = "true", value = "Indicates if the consultation concerns the customer himself (herself) or someone else (child for example)")
  public Boolean isIsTheRequesterThePatient() {
    return isTheRequesterThePatient;
  }

  public void setIsTheRequesterThePatient(Boolean isTheRequesterThePatient) {
    this.isTheRequesterThePatient = isTheRequesterThePatient;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    MedicalConsultationCreation medicalConsultationCreation = (MedicalConsultationCreation) o;
    return Objects.equals(this.appointmentPeriod, medicalConsultationCreation.appointmentPeriod) &&
        Objects.equals(this.effectivePeriod, medicalConsultationCreation.effectivePeriod) &&
        Objects.equals(this.address, medicalConsultationCreation.address) &&
        Objects.equals(this.phones, medicalConsultationCreation.phones) &&
        Objects.equals(this.reason, medicalConsultationCreation.reason) &&
        Objects.equals(this.channel, medicalConsultationCreation.channel) &&
        Objects.equals(this.customerJourneyStep, medicalConsultationCreation.customerJourneyStep) &&
        Objects.equals(this.isTheRequesterThePatient, medicalConsultationCreation.isTheRequesterThePatient);
  }

  @Override
  public int hashCode() {
    return Objects.hash(appointmentPeriod, effectivePeriod, address, phones, reason, channel, customerJourneyStep, isTheRequesterThePatient);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class MedicalConsultationCreation {\n");
    
    sb.append("    appointmentPeriod: ").append(toIndentedString(appointmentPeriod)).append("\n");
    sb.append("    effectivePeriod: ").append(toIndentedString(effectivePeriod)).append("\n");
    sb.append("    address: ").append(toIndentedString(address)).append("\n");
    sb.append("    phones: ").append(toIndentedString(phones)).append("\n");
    sb.append("    reason: ").append(toIndentedString(reason)).append("\n");
    sb.append("    channel: ").append(toIndentedString(channel)).append("\n");
    sb.append("    customerJourneyStep: ").append(toIndentedString(customerJourneyStep)).append("\n");
    sb.append("    isTheRequesterThePatient: ").append(toIndentedString(isTheRequesterThePatient)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

